/*  ==========================================================================
    // Button
    //
    // Your standard button suitable for clicking.
    //
    // .button--light - light
    // .button--mercury - mercury
    // .button--silver - silver
    // .button--stone - stone
    // .button--positive - positive
    // .button--calm - calm
    // .button--balanced - balanced
    // .button--energized - energized
    // .button--assertive - assertive
    // .button--dark - dark
    // .button--royal - royal
    // .button--facebook - facebook
    // .button--transparent - transparent
    //
    // Markup: forms-button.html
    //
    // Style guide: Modules.Button
/*  ========================================================================== */

    button::-moz-focus-inner,
    input::-moz-focus-inner
    {
        padding: 0;
        border: 0;
    }

    button:focus
    {
        outline: none;
    }

    .button
    {
        @include button-style($button-default-bg, $button-default-border, $button-default-hover-bg, $button-default-hover-border, $button-default-active-bg, $button-default-active-border, $button-default-text, $button-default-hover-text, $button-default-box-shadow);

        position: relative;
        display: inline-block;
        margin: 0;
        padding: $button-padding;

        border-width: $button-border-width;
        border-style: solid;
        border-radius: $button-border-radius;
        vertical-align: middle;
        text-align: center;
        text-overflow: ellipsis;
        text-decoration: none;
        font-size: $button-font-size;
        line-height: $button-line-height;
        font-weight: $button-font-weight;
        cursor: pointer;
        transition: all 0.4s;
        -webkit-tap-highlight-color: $button-default-hover-bg;

        &.button--light
        {
            @include button-style($button-light-bg, $button-light-border, $button-light-hover-bg, $button-light-hover-border, $button-light-active-bg, $button-light-active-border, $button-light-text, $button-light-hover-text, $button-light-box-shadow);
            
            -webkit-tap-highlight-color: $button-light-hover-bg;
        }

        &.button--mercury
        {
            @include button-style($button-mercury-bg, $button-mercury-border, $button-mercury-hover-bg, $button-mercury-hover-border, $button-mercury-active-bg, $button-mercury-active-border, $button-mercury-text, $button-mercury-hover-text, $button-mercury-box-shadow);
            
            -webkit-tap-highlight-color: $button-mercury-hover-bg;
        }

        &.button--silver
        {
            @include button-style($button-silver-bg, $button-silver-border, $button-silver-hover-bg, $button-silver-hover-border, $button-silver-active-bg, $button-silver-active-border, $button-silver-text, $button-silver-hover-text, $button-silver-box-shadow);
            
            -webkit-tap-highlight-color: $button-silver-hover-bg;
        }

        &.button--stone
        {
            @include button-style($button-stone-bg, $button-stone-border, $button-stone-hover-bg, $button-stone-hover-border, $button-stone-active-bg, $button-stone-active-border, $button-stone-text, $button-stone-hover-text, $button-stone-box-shadow);
            
            -webkit-tap-highlight-color: $button-stone-hover-bg;
        }

        &.button--positive
        {
            @include button-style($button-positive-bg, $button-positive-border, $button-positive-hover-bg, $button-positive-hover-border, $button-positive-active-bg, $button-positive-active-border, $button-positive-text, $button-positive-hover-text, $button-positive-box-shadow);
            
            -webkit-tap-highlight-color: $button-positive-hover-bg;
        }

        &.button--calm
        {
            @include button-style($button-calm-bg, $button-calm-border, $button-calm-hover-bg, $button-calm-hover-border, $button-calm-active-bg, $button-calm-active-border, $button-calm-text, $button-calm-hover-text, $button-calm-box-shadow);
            
            -webkit-tap-highlight-color: $button-calm-hover-bg;
        }

        &.button--balanced
        {
            @include button-style($button-balanced-bg, $button-balanced-border, $button-balanced-hover-bg, $button-balanced-hover-border, $button-balanced-active-bg, $button-balanced-active-border, $button-balanced-text, $button-balanced-hover-text, $button-balanced-box-shadow);
            
            -webkit-tap-highlight-color: $button-balanced-hover-bg;
        }

        &.button--energized
        {
            @include button-style($button-energized-bg, $button-energized-border, $button-energized-hover-bg, $button-energized-hover-border, $button-energized-active-bg, $button-energized-active-border, $button-energized-text, $button-energized-hover-text, $button-energized-box-shadow);
            
            -webkit-tap-highlight-color: $button-energized-hover-bg;
        }

        &.button--assertive
        {
            @include button-style($button-assertive-bg, $button-assertive-border, $button-assertive-hover-bg, $button-assertive-hover-border, $button-assertive-active-bg, $button-assertive-active-border, $button-assertive-text, $button-assertive-hover-text, $button-assertive-box-shadow);
            
            -webkit-tap-highlight-color: $button-assertive-hover-bg;
        }

        &.button--dark
        {
            @include button-style($button-dark-bg, $button-dark-border, $button-dark-hover-bg, $button-dark-hover-border, $button-dark-active-bg, $button-dark-active-border, $button-dark-text, $button-dark-hover-text, $button-dark-box-shadow);
            
            -webkit-tap-highlight-color: $button-dark-hover-bg;
        }

        &.button--royal
        {
            @include button-style($button-royal-bg, $button-royal-border, $button-royal-hover-bg, $button-royal-hover-border, $button-royal-active-bg, $button-royal-active-border, $button-royal-text, $button-royal-hover-text, $button-royal-box-shadow);
            
            -webkit-tap-highlight-color: $button-royal-hover-bg;
        }

        &.button--facebook
        {
            @include button-style($button-facebook-bg, $button-facebook-border, $button-facebook-hover-bg, $button-facebook-hover-border, $button-facebook-active-bg, $button-facebook-active-border, $button-facebook-text, $button-facebook-hover-text, $button-facebook-box-shadow);
            padding-bottom: 10px;
            -webkit-tap-highlight-color: $button-facebook-hover-bg;

            svg
            {
              vertical-align: middle;
              display: inline-block;
            }
        }

        &.button--transparent
        {
            @include button-style($button-transparent-bg, $button-transparent-border, $button-transparent-hover-bg, $button-transparent-hover-border, $button-transparent-active-bg, $button-transparent-active-border, $button-transparent-text, $button-transparent-hover-text, $button-transparent-box-shadow);
            
            -webkit-tap-highlight-color: $button-transparent-hover-bg;
        }
    }